diff --git a/src/main/java/org/distorted/objectlib/main/Twisty12.java b/src/main/java/org/distorted/objectlib/main/Twisty12.java
index 7c37ec4a..97317951 100644
--- a/src/main/java/org/distorted/objectlib/main/Twisty12.java
+++ b/src/main/java/org/distorted/objectlib/main/Twisty12.java
@@ -53,9 +53,9 @@ public abstract class Twisty12 extends TwistyObject
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public Twisty12(int numLayers, int realSize, Static4D quat, DistortedTexture texture, MeshSquare mesh,
-           DistortedEffects effects, int[][] moves, ObjectList list, Resources res, int scrWidth)
+           DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(numLayers, realSize, quat, texture, mesh, effects, moves, list, res, scrWidth);
+    super(numLayers, realSize, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/main/Twisty4.java b/src/main/java/org/distorted/objectlib/main/Twisty4.java
index 2176fa05..2dcb2dd5 100644
--- a/src/main/java/org/distorted/objectlib/main/Twisty4.java
+++ b/src/main/java/org/distorted/objectlib/main/Twisty4.java
@@ -39,9 +39,9 @@ public abstract class Twisty4 extends TwistyObject
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public Twisty4(int numLayers, int realSize, Static4D quat, DistortedTexture texture, MeshSquare mesh,
-          DistortedEffects effects, int[][] moves, ObjectList list, Resources res, int scrWidth)
+          DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(numLayers, realSize, quat, texture, mesh, effects, moves, list, res, scrWidth);
+    super(numLayers, realSize, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/main/Twisty6.java b/src/main/java/org/distorted/objectlib/main/Twisty6.java
index 2308a529..4891bcd8 100644
--- a/src/main/java/org/distorted/objectlib/main/Twisty6.java
+++ b/src/main/java/org/distorted/objectlib/main/Twisty6.java
@@ -40,9 +40,9 @@ public abstract class Twisty6 extends TwistyObject
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public Twisty6(int numLayers, int realSize, Static4D quat, DistortedTexture texture, MeshSquare mesh,
-          DistortedEffects effects, int[][] moves, ObjectList list, Resources res, int scrWidth)
+          DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(numLayers, realSize, quat, texture, mesh, effects, moves, list, res, scrWidth);
+    super(numLayers, realSize, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/main/Twisty8.java b/src/main/java/org/distorted/objectlib/main/Twisty8.java
index 40b0d329..1bc12880 100644
--- a/src/main/java/org/distorted/objectlib/main/Twisty8.java
+++ b/src/main/java/org/distorted/objectlib/main/Twisty8.java
@@ -41,9 +41,9 @@ public abstract class Twisty8 extends TwistyObject
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public Twisty8(int numLayers, int realSize, Static4D quat, DistortedTexture texture, MeshSquare mesh,
-          DistortedEffects effects, int[][] moves, ObjectList list, Resources res, int scrWidth)
+          DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(numLayers, realSize, quat, texture, mesh, effects, moves, list, res, scrWidth);
+    super(numLayers, realSize, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/main/TwistyObject.java b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
index c9d2f7a0..d47abdb5 100644
--- a/src/main/java/org/distorted/objectlib/main/TwistyObject.java
+++ b/src/main/java/org/distorted/objectlib/main/TwistyObject.java
@@ -102,7 +102,6 @@ public abstract class TwistyObject extends DistortedNode
   private final Static3D mNodeScale;
   private final Static4D mQuat;
   private final int mNumLayers, mRealSize;
-  private final ObjectList mList;
   private final DistortedEffects mEffects;
   private final VertexEffectRotate mRotateEffect;
   private final Dynamic1D mRotationAngle;
@@ -134,7 +133,7 @@ public abstract class TwistyObject extends DistortedNode
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   TwistyObject(int numLayers, int realSize, Static4D quat, DistortedTexture nodeTexture, MeshSquare nodeMesh,
-               DistortedEffects nodeEffects, int[][] moves, ObjectList list, Resources res, int screenWidth)
+               DistortedEffects nodeEffects, int[][] moves, Resources res, int screenWidth)
     {
     super(nodeTexture,nodeEffects,nodeMesh);
 
@@ -144,7 +143,6 @@ public abstract class TwistyObject extends DistortedNode
 
     mNumLayers = numLayers;
     mRealSize = realSize;
-    mList = list;
     mOrigPos = getCubitPositions(mNumLayers);
     mAxis = getRotationAxis();
     mInitScreenRatio = getScreenRatio();
@@ -211,7 +209,7 @@ public abstract class TwistyObject extends DistortedNode
     if( mNumTexCols*mNumTexRows < NUM_TEXTURES+1 ) mNumTexRows++;
 
     CUBITS = new Cubit[NUM_CUBITS];
-    createMeshAndCubits(list,res);
+    createMeshAndCubits(res);
     createDataStructuresForSolved(numLayers);
 
     mTexture = new DistortedTexture();
@@ -268,7 +266,7 @@ public abstract class TwistyObject extends DistortedNode
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
-  private void createMeshAndCubits(ObjectList list, Resources res)
+  private void createMeshAndCubits(Resources res)
     {
     int resourceID= getResource(mNumLayers);
 
@@ -999,17 +997,19 @@ public abstract class TwistyObject extends DistortedNode
       quats.append(" ");
       }
 
+    String name = intGetObjectList(mNumLayers).name();
+
     if( BuildConfig.DEBUG )
       {
       android.util.Log.e("quats" , quats.toString());
-      android.util.Log.e("object", mList.name()+"_"+mNumLayers);
+      android.util.Log.e("object", name);
       }
     else
       {
       Exception ex = new Exception(message);
       FirebaseCrashlytics crashlytics = FirebaseCrashlytics.getInstance();
       crashlytics.setCustomKey("quats" , quats.toString());
-      crashlytics.setCustomKey("object", mList.name()+"_"+mNumLayers );
+      crashlytics.setCustomKey("object", name);
       crashlytics.recordException(ex);
       }
     }
@@ -1272,7 +1272,7 @@ public abstract class TwistyObject extends DistortedNode
 
   public ObjectList getObjectList()
     {
-    return mList;
+    return intGetObjectList(mNumLayers);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -1304,6 +1304,7 @@ public abstract class TwistyObject extends DistortedNode
   protected abstract ObjectSticker retSticker(int face);
   protected abstract int getFaceColor(int cubit, int cubitface, int numLayers);
   protected abstract int getResource(int mNumLayers);
+  protected abstract ObjectList intGetObjectList(int numLayers);
 
   public abstract Movement getMovement();
   public abstract Static3D[] getRotationAxis();
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
index 8265b147..e03ff957 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
@@ -37,7 +37,7 @@ public class TwistyBandaged2Bar extends TwistyBandagedAbstract
   public TwistyBandaged2Bar(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                             DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, quat, texture, mesh, effects, moves, ObjectList.BAN2, res, scrWidth);
+    super(size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -115,6 +115,13 @@ public class TwistyBandaged2Bar extends TwistyBandagedAbstract
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.BAN2_3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
   public int getObjectName(int numLayers)
     {
     return R.string.bandaged_2bar;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
index e8a0a2bc..0e67bd08 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
@@ -37,7 +37,7 @@ public class TwistyBandaged3Plate extends TwistyBandagedAbstract
   public TwistyBandaged3Plate(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                               DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, quat, texture, mesh, effects, moves, ObjectList.BAN3, res, scrWidth);
+    super(size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -122,6 +122,13 @@ public class TwistyBandaged3Plate extends TwistyBandagedAbstract
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.BAN3_3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
   public int getObjectName(int numLayers)
     {
     return R.string.bandaged_3plate;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
index fab9d7ca..bf0857e2 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedAbstract.java
@@ -31,7 +31,6 @@ import org.distorted.library.type.Static4D;
 
 import org.distorted.objectlib.main.Movement;
 import org.distorted.objectlib.main.Movement6;
-import org.distorted.objectlib.main.ObjectList;
 import org.distorted.objectlib.main.ObjectShape;
 import org.distorted.objectlib.main.ObjectSticker;
 import org.distorted.objectlib.main.ScrambleState;
@@ -81,9 +80,9 @@ abstract class TwistyBandagedAbstract extends Twisty6
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   TwistyBandagedAbstract(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
-                         DistortedEffects effects, int[][] moves, ObjectList list, Resources res, int scrWidth)
+                         DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, list, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
index c22e989d..eae3b9c1 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
@@ -37,7 +37,7 @@ public class TwistyBandagedEvil extends TwistyBandagedAbstract
   public TwistyBandagedEvil(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                             DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, quat, texture, mesh, effects, moves, ObjectList.BAN4, res, scrWidth);
+    super(size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -246,6 +246,13 @@ public class TwistyBandagedEvil extends TwistyBandagedAbstract
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC API
 
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.BAN4_3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
   public int getObjectName(int numLayers)
     {
     return R.string.bandaged_evil;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
index ef5c16bf..958186df 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
@@ -37,7 +37,7 @@ public class TwistyBandagedFused extends TwistyBandagedAbstract
   public TwistyBandagedFused(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                              DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, quat, texture, mesh, effects, moves, ObjectList.BAN1, res, scrWidth);
+    super(size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -115,6 +115,13 @@ public class TwistyBandagedFused extends TwistyBandagedAbstract
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 // PUBLIC APi
 
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.BAN1_3;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
   public int getObjectName(int numLayers)
     {
     return R.string.bandaged_fused;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyCube.java b/src/main/java/org/distorted/objectlib/objects/TwistyCube.java
index 95bde7fb..3a7f1c2b 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyCube.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyCube.java
@@ -67,7 +67,7 @@ public class TwistyCube extends Twisty6
   public TwistyCube(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                     DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.CUBE, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -394,6 +394,21 @@ public class TwistyCube extends Twisty6
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    switch(numLayers)
+      {
+      case 2: return ObjectList.CUBE_2;
+      case 3: return ObjectList.CUBE_3;
+      case 4: return ObjectList.CUBE_4;
+      case 5: return ObjectList.CUBE_5;
+      }
+
+    return ObjectList.CUBE_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
index 0e630478..3ad909a4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
@@ -71,7 +71,7 @@ public class TwistyDiamond extends Twisty8
   public TwistyDiamond(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                        DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.DIAM, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -536,6 +536,20 @@ public class TwistyDiamond extends Twisty8
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    switch(numLayers)
+      {
+      case 2: return ObjectList.DIAM_2;
+      case 3: return ObjectList.DIAM_3;
+      case 4: return ObjectList.DIAM_4;
+      }
+
+    return ObjectList.DIAM_2;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
index d6897e93..2af485c6 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
@@ -73,9 +73,9 @@ abstract class TwistyDino extends Twisty6
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   TwistyDino(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
-             DistortedEffects effects, int[][] moves, ObjectList obj, Resources res, int scrWidth)
+             DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, obj, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
index 991f77f8..603a33d5 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino4.java
@@ -41,7 +41,7 @@ public class TwistyDino4 extends TwistyDino
   public TwistyDino4(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                      DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, quat, texture, mesh, effects, moves, ObjectList.DIN4, res, scrWidth);
+    super(size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -96,6 +96,13 @@ public class TwistyDino4 extends TwistyDino
     return true;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.DIN4_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
index 12a90337..c3b3ed0c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino6.java
@@ -41,7 +41,7 @@ public class TwistyDino6 extends TwistyDino
   public TwistyDino6(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                      DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, quat, texture, mesh, effects, moves, ObjectList.DINO, res, scrWidth);
+    super(size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -98,6 +98,13 @@ public class TwistyDino6 extends TwistyDino
     return 2;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.DINO_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
index b6567505..181b7ea3 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
@@ -79,7 +79,7 @@ public class TwistyHelicopter extends Twisty6
   public TwistyHelicopter(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                           DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.HELI, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -456,6 +456,13 @@ public class TwistyHelicopter extends Twisty6
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.HELI_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
index bfd4e748..53e25e8b 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
@@ -78,7 +78,7 @@ public class TwistyIvy extends Twisty6
   public TwistyIvy(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                    DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.IVY, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -483,6 +483,13 @@ public class TwistyIvy extends Twisty6
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.IVY_2;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
index c60670ab..b3163e47 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
@@ -75,7 +75,7 @@ public class TwistyJing extends Twisty4
   public TwistyJing(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                     DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.JING, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -442,6 +442,13 @@ public class TwistyJing extends Twisty4
     return mBasicAngle;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    return ObjectList.JING_2;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
index cc718752..622b7c39 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
@@ -46,7 +46,7 @@ public class TwistyKilominx extends TwistyMinx
   public TwistyKilominx(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                         DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.KILO, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -514,11 +514,13 @@ public class TwistyKilominx extends TwistyMinx
 
   protected int getNumCubitVariants(int numLayers)
     {
-    int[] sizes = ObjectList.KILO.getSizes();
-    int variants = sizes.length;
-    int highestSize = sizes[variants-1];
+    switch(numLayers)
+      {
+      case 3: return 1;
+      case 5: return 4;
+      }
 
-    return highestSize-1;
+    return 1;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -537,11 +539,7 @@ public class TwistyKilominx extends TwistyMinx
       return type+1;
       }
 
-    int[] sizes = ObjectList.KILO.getSizes();
-    int variants = sizes.length;
-    int highestSize = sizes[variants-1];
-
-    return highestSize-2;
+    return getNumCubitVariants(numLayers)-1;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -696,6 +694,19 @@ public class TwistyKilominx extends TwistyMinx
     return 2;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    switch(numLayers)
+      {
+      case 3: return ObjectList.KILO_3;
+      case 5: return ObjectList.KILO_5;
+      }
+
+    return ObjectList.KILO_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
index 17336459..82d065bf 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
@@ -47,7 +47,7 @@ public class TwistyMegaminx extends TwistyMinx
   public TwistyMegaminx(int size, Static4D quat, DistortedTexture texture, MeshSquare mesh,
                         DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(size, size, quat, texture, mesh, effects, moves, ObjectList.MEGA, res, scrWidth);
+    super(size, size, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -430,10 +430,13 @@ public class TwistyMegaminx extends TwistyMinx
 
   protected int getNumCubitVariants(int numLayers)
     {
-    int[] sizes = ObjectList.MEGA.getSizes();
-    int variants = sizes.length;
+    switch(numLayers)
+      {
+      case 3: return 3;
+      case 5: return 4;
+      }
 
-    return 2+(sizes[variants-1]-1)/2;
+    return 3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -452,11 +455,7 @@ public class TwistyMegaminx extends TwistyMinx
       return type+1;
       }
 
-    int[] sizes = ObjectList.MEGA.getSizes();
-    int variants = sizes.length;
-    int numShapes = 2+(sizes[variants-1]-1)/2;
-
-    return numShapes-1;
+    return getNumCubitVariants(numLayers)-1;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
@@ -602,6 +601,19 @@ public class TwistyMegaminx extends TwistyMinx
     return 4;
     }
 
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public ObjectList intGetObjectList(int numLayers)
+    {
+    switch(numLayers)
+      {
+      case 3: return ObjectList.MEGA_3;
+      case 5: return ObjectList.MEGA_5;
+      }
+
+    return ObjectList.MEGA_3;
+    }
+
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   public int getObjectName(int numLayers)
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMinx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMinx.java
index 3f618c36..2c9e1251 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMinx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMinx.java
@@ -98,9 +98,9 @@ abstract class TwistyMinx extends Twisty12
 ///////////////////////////////////////////////////////////////////////////////////////////////////
 
   TwistyMinx(int numLayers, int realSize, Static4D quat, DistortedTexture texture, MeshSquare mesh,
-             DistortedEffects effects, int[][] moves, ObjectList obj, Resources res, int scrWidth)
+             DistortedEffects effects, int[][] moves, Resources res, int scrWidth)
     {
-    super(numLayers, realSize, quat, texture, mesh, effects, moves, obj, res, scrWidth);
+    super(numLayers, realSize, quat, texture, mesh, effects, moves, res, scrWidth);
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
